% demoPCA

% Assume we have a dxn data matrix D, where each instance is a column
% vector.

load faces.mat;

numDims = size(D,1);
numCases = size(D,2);
[vecs,vals,psi] = pc_evectors(D,numCases); % Uses trick with eig on A'A

% Visualize eigenvectors, plotted in 2D
figure(1)
for i = 1:9
  subplot(3,3,i)
  pc = reshape(vecs(:,i),112,92);
  imagesc(pc)
  colormap gray
  daspect([1 1 1]);
  subplot(3,3,2)
  title('Top 9 Principal Components plotted in 2D')
end

% Visualize reconstruction from PCA space
origImg = D(:,1); % Grab image 1

figure(2)
imagesc(reshape(origImg,112,92))
title('Original Image')
colormap gray
daspect([1 1 1]);

proj50 = vecs(:,1:50)'*(origImg - psi); % Project to PCA space using 50 top ev's
recon50 = vecs(:,1:50)*proj50 + psi; % Reconstruct
figure(3)
imagesc(reshape(recon50,112,92));
title('Reconstruction using 50 Principal Components')
colormap gray
daspect([1 1 1]);

proj300 = vecs(:,1:300)'*(origImg - psi); % Project to PCA space using 50 top ev's
recon300 = vecs(:,1:300)*proj300 + psi; % Reconstruct
figure(4)
imagesc(reshape(recon300,112,92));
title('Reconstruction using 300 Principal Components')
colormap gray
daspect([1 1 1]);